﻿var emptyMsgCallsDiv = $("<div style='padding:5px;' class='hidden'><span>Neexistuje žádný hovor</span></div>");
$(document).ready(function () {
    initDateRangePicker("#FilterTimespan");

    filterSetBackground();

    $(".datepicker").datepicker();

    $("body").on("click", ".closeFilter", function () {
        $("#FilterTimespan").val("");
        $("#FilterUniqueId").val("");
        $("#FilterPhoneNumber").val("");
        $("#FilterDescription").val("");
        $("#FilterCallerProviderKey").val(null);
        $("#FilterCallerProviderKey").trigger("change");
        $("#FilterOperatorProviderKey").val(null);
        $("#FilterOperatorProviderKey").trigger("change");
        $("#FilterTicketId").val(null);
        $("#FilterTicketId").trigger("change");
        $("#FilterCustomerId").val(null);
        $("#FilterCustomerId").trigger("change");
        $("#FilterWay").val(null);
        $("#FilterWay").trigger("change");
        $("select.select2TreeCategories").val(null);
        $("select.select2TreeCategories").trigger("change");
        
        $("#CallsFilter").hide();

        filterJqGrid();
    });

    $("body").on("click", ".showFilter", function () {
        if (!$("#CallsFilter").is(":visible")) {
            $("#CallsFilter").show();
        }
        else {
            $("#CallsFilter").hide();
        }
    });

    $("#dialog-call-column-settings").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        close: function (event, ui) {
            if (disableReload) {
                disableReload = false;
            }
            else {
                location.reload();
            }
        },
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    $("#dialog-call-column-settings").dialog("close");
                }
            }]
    });


    $("#dialog-call-column-settings").sortable({
        placeholder: "ui-state-highlight margin-bottom-small",
        stop: function (event, ui) {
            var fieldtypes = $(this).closest("#dialog-call-column-settings").find(".right-box-settings").map(function () {
                return $(this).data("fieldtype");
            }).get();
            var callfieldids = $(this).closest("#dialog-call-column-settings").find(".right-box-settings").map(function () {
                return $(this).data("callfieldid");
            }).get();
            var bools = $(this).closest("#dialog-call-column-settings").find(".right-box-settings-show").map(function () {
                return $(this).is(":checked");
            }).get();
            $.ajax({
                url: RQ_URL + '/Call/ChangePositions',
                data: {
                    fieldtypes: fieldtypes,
                    callfieldids: callfieldids,
                    typesShow: bools
                },
                type: "POST"
            });
        }
    });

    $("#dialog-call-column-settings").on("change", ".right-box-settings-show", function () {
        var fieldtypes = $(this).closest("#dialog-call-column-settings").find(".right-box-settings").map(function () {
            return $(this).data("fieldtype");
        }).get();
        var callfieldids = $(this).closest("#dialog-call-column-settings").find(".right-box-settings").map(function () {
            return $(this).data("callfieldid");
        }).get();
        var bools = $(this).closest("#dialog-call-column-settings").find(".right-box-settings-show").map(function () {
            return $(this).is(":checked");
        }).get();
        $.ajax({
            url: RQ_URL + '/Call/ChangePositions',
            data: {
                fieldtypes: fieldtypes,
                callfieldids: callfieldids,
                typesShow: bools
            },
            type: "POST"
        });
    });

    $("#FilterCallerProviderKey").select2({
        minimumInputLength: 0,
        width: '100%',
        multiple: true,
        placeholder: Localization_Search,
        ajax: {
            url: RQ_URL + '/Account/UsersForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                    includeSmartUsers: true,
                    includeEndUsers: true,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: true,
        },
        escapeMarkup: function (markup) { return markup; },
        templateResult: formatUsersForSelect2AjaxData,
        templateSelection: formatUsersForSelect2AjaxElement,
    });

    $("#FilterOperatorProviderKey").select2({
        minimumInputLength: 0,
        width: '100%',
        multiple: true,
        placeholder: Localization_Search,
        ajax: {
            url: RQ_URL + '/Account/UsersForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                    includeSmartUsers: false,
                    includeEndUsers: false,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: true,
        },
        escapeMarkup: function (markup) { return markup; },
        templateResult: formatUsersForSelect2AjaxData,
        templateSelection: formatUsersForSelect2AjaxElement,
    });
});

function wayFormatter(cellValue, options, rowObject) {
    return $('<img/>', {
        src: RQ_URL + "/Images/Call/" + (cellValue === "In" ? "callIn.svg" : "callOut.svg"),
        height: 34,
    }).prop('outerHTML');
}

function actionsFormatter(cellValue, options, rowObject) {
    return "<a href='" + RQ_URL + "/Call/CallSession/" + rowObject.UniqueId + "'><i class='fa fa-eye fa-fw' aria-hidden='true'></i></a>";
}

function replayFormatter(cellValue, options, rowObject) {
    if (rowObject.FileName && rowObject.FileName.length > 0 && rowObject.Answered) {
        return "<a href='" + RQ_URL + "/Call/RecordContent/" + rowObject.UniqueId + "?fileName=" + rowObject.FileName + "'><i class='fa fa-volume-up fa-fw' aria-hidden='true'></i></a>";
    }
    return '<i class="fa fa-ban fa-fw" aria-hidden="true"></i>';
}

function ticketsFormatter(cellValue, options, rowObject) {
    if (rowObject.Tickets && rowObject.Tickets.length > 0) {
        var html = "";
        for (var i = 0; i < rowObject.Tickets.length; i++) {
            html += "<a href='" + RQ_URL + "/Tickets/Show/" + rowObject.Tickets[i].TicketREF + "'>" + rowObject.Tickets[i].Subject + "</a>";
            if (i + 1 < rowObject.Tickets.length) {
                html += ", ";
            }
        }
        return html;
    }
    return "";
}

function categoryItemsFormatter(cellValue, options, rowObject) {
    if (rowObject.CategoryItems && rowObject.CategoryItems.length > 0) {
        var html = "";
        for (var i = 0; i < rowObject.CategoryItems.length; i++) {
            html += "<i class='fa fa-fw fa-flag' style='color:" + rowObject.CategoryItems[i].Color + "'></i> " + rowObject.CategoryItems[i].Name;
        }
        return html;
    }
    return "";
}


function companyFormatter(cellValue, options, rowObject) {
    var companyHtml = cellValue != null ? "<a href='" + RQ_URL + "/Customers/Edit/" + rowObject.CallerCustomerId + "'>" + rowObject.CallerCustomerName + "</a>" : "";
    return companyHtml;
}

function utcDateFormatter(cellValue, options, rowObject) {
    return moment(moment.utc(cellValue).toDate()).format('l LT');//format('DD.MM.YYYY HH:mm');
}

function openCallColumnSettings() {
    $("#dialog-call-column-settings").html("<div class='loading-32'></div>");
    $("#dialog-call-column-settings").dialog("open");
    $("#dialog-call-column-settings").load(RQ_URL + "/Call/LoadFields", function () {
        disableReload = true;
        $("#dialog-call-column-settings").dialog("close");
        $("#dialog-call-column-settings").dialog("open");
    });
}

function operatorFormatter(cellValue, options, rowObject) {
    var operatorHtml = cellValue != null ?  rowObject.OperatorAvatar + " " + "<a href='javascript:void(0);' class='user-info' data-userproviderkey='" + rowObject.OperatorKey + "'>" + rowObject.OperatorFullName + "</a>" : "";
    return operatorHtml;
}

function callerFormatter(cellValue, options, rowObject) {
    var operatorHtml = cellValue != null ? rowObject.CallerAvatar + " " + "<a href='" + RQ_URL + "/Customers/User/" + rowObject.CallerKey + "'>" + rowObject.CallerFullName + "</a>" : "";
    return operatorHtml;
}

function customFieldFormatter(cellValue, options, rowObject) {
    //nepoužívají se všechny, je to příprava na sjednocení formulářů
    var name = options.colModel.name;
    var obj = jQuery.grep(rowObject.CallFields, function (n, i) {
        return (n.Id == name);
    });
    if (obj.length > 0) {
        var o = obj[0];
        switch (o.Type) {
            //DropDown
            case 1:
                if (o.SelectValue == null)
                    return "";
                return o.SelectValue;
                break;
            //Textbox, Multiline
            case 2:
            case 3:
            case 13:
                if (o.TextBoxValue == null)
                    return "";
                return o.TextBoxValue;
                break;
            //Url
            case 12:
                return (o.TextBoxValue == "" || o.TextBoxValue == null ? "" : "<a href='" + (o.TextBoxValue.indexOf("://") == -1 ? "//" + o.TextBoxValue : o.TextBoxValue) + "'>" + o.TextBoxValue + "</a>");
            //Numberic
            case 4:
                if (o.LongValue == null)
                    return "";
                return o.LongValue;
                break;
            //Decimal
            case 5:
                if (o.DoubleValue == null)
                    return "";
                return o.DoubleValue;
                break;
            //Checkbox
            case 6:
                if (o.CheckBoxValue == null)
                    return "";
                return o.CheckBoxValue == true ? ' <i class="fa fa-check" aria-hidden="true" data-toggle="tooltip" title="' + Localization_Yes + '"></i>' : '<i class="fa fa-ban" aria-hidden="true" data-toggle="tooltip" title="' + Localization_No + '"></i>';
                break;
            //Date
            case 10:
                if (o.DateValue == null)
                    return "";
                return o.DateValue;
                break;

        }
    }
    return "";
}

function filterJqGrid() {
    filterSetBackground();
    cleanSelectedIds();
    reloadJqGrid();
}

function cleanSelectedIds() {
    selectedIds = [];
}

function filterSetBackground() {
    var categoryItems = Array();
    $.each($(".select2TreeCategories"), function (index, value) {
        if ($(value).val() != "") {
            categoryItems.push($(value).val());
        }
    }); 
    if ($("#FilterPhoneNumber").val() != "" || $("#FilterTimespan").val() != "" ||
        $("#FilterUniqueId").val() != "" || $("#FilterDescription").val() != "" || 
        ($("#FilterCustomerId").val() != null && $("#FilterCustomerId").val() != "") ||
        ($("#FilterWay").val() != null && $("#FilterWay").val() != "") ||
        ($("#FilterTicketId").val() != null && $("#FilterTicketId").val() != "") || 
        ($("#FilterCallerProviderKey").val() != null && $("#FilterCallerProviderKey").val() != "") ||
        ($("#FilterOperatorProviderKey").val() != null && $("#FilterOperatorProviderKey").val() != "") ||
        categoryItems.length > 0) {
        $(".showFilter").css("background-color", "#5cb85c");
    } else {
        $(".showFilter").css("background-color", "");
    }
}

function reloadJqGrid() {
    $('#jqGridCalls').trigger("reloadGrid");
}
