﻿var showHistoryBool = false;
function addNewEventClassic() {
    clearEventClassicDialog();
    $('#CreateNewEventSaveButton').button('option', 'label', Localization_Create);
    $("#EventClassicCalendars").trigger("change");
    $("#EventClassicTickets").val(ticketId);
    $("#dialog-create-new-event").dialog("option", 'title', Localization_CalendarScheduler_NewEvent);
    $("#dialog-create-new-event").dialog("open");
}

function clearEventClassicDialog() {
    $(".error").hide();
    $(".shared-calendar").hide();
    $("#eventClassicId").val("");
    $("#EventClassicFromDate").datepicker("setDate", Date.now());
    $("#EventClassicToDate").datepicker("setDate", Date.now());
    $("#EventClassicLocation").val("");
    $("#EventClassicName").val("");
    $("#EventClassicDescription").val("");
    $("#EventClassicTickets").val("");
    $("#EventClassicType").val("-1").trigger("change");
    $("#EventClassicAllDay").prop("checked", true);
    $("#RemindeEverybodyEventClassic").prop("checked", false);
    $("#divRemindersEventClassic .text-with-hiding-buttons").remove();
    var html = $("#ReminderTemplate").html();

    $('#divRemindersEventClassic').append(html);

    checkEventClassicAllDay();
}

function checkEventClassicAllDay() {
    if ($("#EventClassicAllDay").prop("checked")) {
        $(".timepicker").prop("disabled", true);
        var dateNow = new Date(Date.now());
        dateNow.setMinutes(0);
        $("#EventClassicFromTime").timepicker("setTime", dateNow);
        dateNow.setHours(dateNow.getHours() + 1);
        $("#EventClassicToTime").timepicker("setTime", dateNow);
    }
    else {
        $(".timepicker").prop("disabled", false);
    }
}

function deleteEvent(id) {
    calendarSchedulerEventId = id;
    $("#dialog-ticket-view-delete-calendar-scheduler-event").dialog("open");
}

function showHistory() {
    showHistoryBool = true;
    reloadCalendarEvents();
}

function hideHistory() {
    showHistoryBool = false;
    reloadCalendarEvents();
}

function reloadCalendarEvents() {
    $("#ticket-calendar-scheduler-events .block-body").html("<div class='loading-32'></div>");
    $("#ticket-calendar-scheduler-events").load(RQ_URL + "/Tickets/ReloadCalendarSchedulerEvents/" + ticketId + "?history=" + showHistoryBool, function () { initBsTooltip(); });
}

function convertTimeToNumber(time) {
    var tm = time.split(":");
    time = parseInt(tm[0]) * 60;
    time += parseInt(tm[1]);
    return time;
}

function createReminderCollection(id) {
    var result = new Array();
    $.each($(id).find(".text-with-hiding-buttons"), function (key, value) {
        result.push({ Id: $(value).find(".reminder-type").data("id"), Type: $(value).find(".reminder-type").val(), Time: $(value).find(".reminder-time").val() });
    });
    return result;
}

function getDataForEvent(id) {
    OnAjaxBegin(Localization_CalendarScheduler_LoadingData);
    $.ajax({
        url: RQ_URL + '/CalendarScheduler/GetDataById?id=' + id,
        type: "GET",
        contentType: "application/json; charset=utf-8",
        success: function (event) {
            if (event === false) {
                reloadCalendarEvents();
            }
            else {
                editEventClassic(event.id, event.description, event.allDay, event.start, event.endForEdit, event.location, event.color, event.title, event.calendarId, event.sendReminderForEveryone, event.reminders, event.type, event.ticketIds, event.tickets);
            }
            OnAjaxComplete();
        },
    });
}

function editEventClassic(id, description, allDay, start, end, location, color, title, calendarId, sendReminderForEveryone, reminders, type, ticketIds, tickets) {
    clearEventClassicDialog();

    $("#eventClassicId").val(id);
    $("#EventClassicFromDate").val(moment.utc(start).locale(language).format('l'));
    $("#EventClassicToDate").val(moment.utc(end).locale(language).format('l'));
    $("#EventClassicFromTime").timepicker('setTime',(moment.utc(start).locale(language).format('HH:mm')));
    $("#EventClassicFromTime").val(moment.utc(start).locale(language).format('HH:mm'));
    $("#EventClassicToTime").timepicker('setTime', (moment.utc(end).locale(language).format('HH:mm')));
    $("#EventClassicToTime").val(moment.utc(end).locale(language).format('HH:mm'));
    $("#EventClassicDescription").val(description);
    $("#EventClassicAllDay").prop("checked", allDay);
    $("#EventClassicType").val(type).trigger("change");
    $("#EventClassicLocation").val(location);
    $("#EventClassicName").val(title);
    $("#EventClassicTickets").val(ticketIds.join(","));
    $("#RemindeEverybodyEventClassic").prop("checked", sendReminderForEveryone);
    $("#divRemindersEventClassic .text-with-hiding-buttons").remove();

    $.each(reminders, function (index, value) {
        var html = $("#ReminderTemplate").html();

        $('#divRemindersEventClassic').append(html);
        $('#divRemindersEventClassic').find(".text-with-hiding-buttons:last .reminder-type").data("id", value.Id);
        $('#divRemindersEventClassic').find(".text-with-hiding-buttons:last .reminder-type").val(value.Type);
        $('#divRemindersEventClassic').find(".text-with-hiding-buttons:last .reminder-time").val(value.Time);
    });
    $("#EventClassicCalendars").val(calendarId).trigger("change");

    checkEventClassicAllDay();
    $('#CreateNewEventSaveButton').button('option', 'label', Localization_Save);
    $("#dialog-create-new-event").dialog("option", 'title', Localization_CalendarScheduler_EditEvent);
    $("#dialog-create-new-event").dialog("open");
}